diff --git a/CHANGELOG b/CHANGELOG
index ef549cf..08afa7c 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -23,6 +23,7 @@
 - add random selection as a master map entry option.
 - fix couple of edge case parse fails of timeout option.
 - check for "*" when looking up wildcard in LDAP.
+- fix LDAP schema discovery.
 
 18/06/2007 autofs-5.0.2
 -----------------------
diff --git a/modules/lookup_ldap.c b/modules/lookup_ldap.c
index a7b315e..9c18ca1 100644
--- a/modules/lookup_ldap.c
+++ b/modules/lookup_ldap.c
@@ -1009,6 +1009,15 @@ int lookup_init(const char *mapfmt, int argc, const char *const *argv, void **co
 			free_context(ctxt);
 			return 1;
 		}
+	} else {
+		const char *class = ctxt->schema->map_class;
+		const char *key = ctxt->schema->map_attr;
+		if (!get_query_dn(ldap, ctxt, class, key)) {
+			unbind_ldap_connection(ldap, ctxt);
+			error(LOGOPT_ANY, MODPREFIX "failed to get query dn");
+			free_context(ctxt);
+			return 1;
+		}
 	}
 	unbind_ldap_connection(ldap, ctxt);
 
